﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;
using System.Diagnostics;
using SilverlightMouseSupport;

namespace DemoSilverlightApplication
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
            // The code generated by the compiler that hooks up 
            // the control variables and the controls
            // does not work correctly when using controls in other XAML namescopes
            // This is a work-around that will hopefully be soon depricated.
            // See also: http://blogs.vertigo.com/personal/jimbg/Blog/archive/2008/10/24/walk-the-visual-tree.aspx
            _txt = _mouseSupport.FindName("_txt") as TextBox;
        }

        private void TextBoxOnMouseWheel(object sender, SilverlightMouseSupport.MouseWheelEventArgs e)
        {
            _logListBox.Items.Add("MouseWheel: Delta = " + e.Delta);
            e.Handled = true;
        }

        private void FullScreenButtonOnClick(object sender, RoutedEventArgs e)
        {
            App.Current.Host.Content.IsFullScreen = !App.Current.Host.Content.IsFullScreen;
            _fullScreenButton.Content = App.Current.Host.Content.IsFullScreen ? "Windowed mode" : "Full Screen Mode";
        }

        private void ClearButtonOnClick(object sender, RoutedEventArgs e)
        {
            _logListBox.Items.Clear();
            
            //the following line will cause an exception when the second line in the constructor is missing!
            _txt.Text = string.Empty;

            
        }

        private void ComboBoxOnMouseWheel(object sender, SilverlightMouseSupport.MouseWheelEventArgs e)
        {
            _logListBox.Items.Add("ComboBox");
            ComboBox comboBox = sender as ComboBox;
            if (comboBox != null)
            {
                if (e.Delta > 0 && comboBox.SelectedIndex > 0)
                {
                    comboBox.SelectedIndex--;
                }
                else if (e.Delta < 0 && comboBox.SelectedIndex < comboBox.Items.Count -1)
                {
                    comboBox.SelectedIndex++;
                }

            }
        }

        private void ListBoxOnMouseWheel(object sender, SilverlightMouseSupport.MouseWheelEventArgs e)
        {
            //note: this is a special ListBox, not a standard Silverlight listbox.
            ListBox listBox = sender as ListBox;
            double scrollStep = 10;
            if (listBox != null)
            {
                ScrollViewer scrollViewer = listBox.ScrollViewer;
                if (scrollViewer != null)
                {
                    if (e.Delta > 0 && scrollViewer.VerticalOffset > 0)
                    {
                        scrollViewer.ScrollToVerticalOffset(scrollViewer.VerticalOffset - e.Delta * scrollStep);
                    }
                    else if (e.Delta < 0 && scrollViewer.VerticalOffset < scrollViewer.ScrollableHeight)
                    {
                        scrollViewer.ScrollToVerticalOffset(scrollViewer.VerticalOffset - e.Delta * scrollStep);
                    }
                }
            }
        }

        private void MouseSupport_MouseWheel(object sender, MouseWheelEventArgs e)
        {

        }

    }
}
